Unit CmdTail;

Interface

Function GetCommandTail(Const ToSkip: LongInt): PChar;

Implementation

Uses
  Windows;

Function GetCommandTail(Const ToSkip: LongInt): PChar;
  Const
    WHITESPACE: Set Of Char = [#9, #32];
  Var
    pCL, pTail: PChar;
    InQuote: Boolean;
    ArgNo, N: LongInt;
  Begin
  pCL := GetCommandLine;
  pTail := Nil;
  If pCL^ <> #0 Then
    Begin
    While pCL^ In WHITESPACE Do  {Skip leading whitespace}
      Inc(pCL);
    InQuote := False;
    pTail := pCL;
    ArgNo := 0;
    For N := 0 To StrLen(pCL) Do
      Begin
      Case pCL[N] Of
        #0:
          Break;
        '"':
          Begin
          InQuote := Not InQuote;
          If InQuote Then
            Begin
            If ArgNo = ToSkip Then
              Break;
            End;
          Inc(pTail);
          End;
        #1..#32:
          Begin
          If (Not InQuote) And (Not (pCL[N - 1] In WHITESPACE)) Then
            Inc(ArgNo);
          Inc(pTail);
          End;
        Else
          Begin
          If ArgNo = ToSkip Then
            Break
          Else
            Inc(pTail);
          End;
      End; {Case}
      End;
    End;
  GetCommandTail := pTail;
  End;

Begin
End.
