Unit
  Exec;

{$MODE OBJFPC}
{$H+}

Interface

Uses
  Windows;

Function RunExecutable(Const Executable, Parameters, StartDir: String;
                       Const WindowState: LongInt;
                       Const Wait, Quiet, Elevate: Boolean): DWORD;

Implementation

Const
  SEE_MASK_DEFAULT           = $00000000;
  SEE_MASK_CLASSNAME         = $00000001;
  SEE_MASK_CLASSKEY          = $00000003;
  SEE_MASK_IDLIST            = $00000004;
  SEE_MASK_INVOKEIDLIST      = $0000000C;
  SEE_MASK_ICON              = $00000010;
  SEE_MASK_HOTKEY            = $00000020;
  SEE_MASK_NOCLOSEPROCESS    = $00000040;
  SEE_MASK_CONNECTNETDRV     = $00000080;
  SEE_MASK_NOASYNC           = $00000100;
  SEE_MASK_FLAG_DDEWAIT      = $00000100;
  SEE_MASK_DOENVSUBST        = $00000200;
  SEE_MASK_FLAG_NO_UI        = $00000400;
  SEE_MASK_UNICODE           = $00004000;
  SEE_MASK_NO_CONSOLE        = $00008000;
  SEE_MASK_ASYNCOK           = $00100000;
  SEE_MASK_NOQUERYCLASSSTORE = $01000000;
  SEE_MASK_HMONITOR          = $00200000;
  SEE_MASK_NOZONECHECKS      = $00800000;
  SEE_MASK_WAITFORINPUTIDLE  = $02000000;
  SEE_MASK_FLAG_LOG_USAGE    = $04000000;

Type
  SHELLEXECUTEINFO = Record
                     cbSize:       DWORD;
                     fMask:        ULONG;
                     hwnd:         ULONG;
                     lpVerb:       LPCTSTR;
                     lpFile:       LPCTSTR;
                     lpParameters: LPCTSTR;
                     lpDirectory:  LPCTSTR;
                     nShow:        LongInt;
                     hInstApp:     HINST;
                     lpIDList:     LPVOID;
                     lpClass:      LPCTSTR;
                     hKeyClass:    HKEY;
                     dwHotKey:     DWORD;
                     hMonitor:     HANDLE;
                     hProcess:     HANDLE;
                     End;
  LPSHELLEXECUTEINFO = ^SHELLEXECUTEINFO;

Function ShellExecuteEx(ExecInfo: LPSHELLEXECUTEINFO): BOOL stdcall;
  external 'shell32.dll' name 'ShellExecuteEx';

Function ToStr(N: DWORD): String;
  Begin
  Str(N, Result);
  End;

Function RunExecutable(Const Executable, Parameters, StartDir: String;
                       Const WindowState: LongInt;
                       Const Wait, Quiet, Elevate: Boolean): DWORD;
  Var
    SEI: SHELLEXECUTEINFO;
    OK: Boolean;
  Begin
  Result := 0;
  FillChar(SEI, SizeOf(SHELLEXECUTEINFO), 0);
  With SEI Do
    Begin
    cbSize := SizeOf(SHELLEXECUTEINFO);
    If Wait Then
      fMask := fMask Or SEE_MASK_NOCLOSEPROCESS;
    If Quiet Then
      fMask := fMask Or SEE_MASK_FLAG_NO_UI;
    If Elevate Then
      lpVerb := 'runas'
    Else
      lpVerb := 'open';
    lpFile := PChar(Executable);
    lpParameters := PChar(Parameters);
    If StartDir <> '' Then
      lpDirectory := PChar(StartDir)
    Else
      lpDirectory := Nil;
    nShow := WindowState;
    End;
  OK := ShellExecuteEx(@SEI);
  If Not OK Then
    Result := GetLastError;
  If OK And Wait Then
    Begin
    WaitForSingleObject(SEI.hProcess, INFINITE);
    GetExitCodeProcess(SEI.hProcess, Result);
    End;
  End;

Begin
End.
