Unit
  Registry;

{$MODE OBJFPC}
{$H+}

Interface

Uses
  Windows;

Function GetRegistryStringValue(Hive: HKEY; SubKey, ValueName: String; Var ValueData: String): DWORD;

Implementation

Function ReadRegistryValue(Hive: HKEY;
                   pSubKey, pValueName: PChar;
                   Var ValueType: DWORD;
                   Var pData: Pointer;
                   Var cbData: DWORD): DWORD;
  Var
    hkHandle: HANDLE;
  Begin
  Result := RegOpenKeyEx(Hive, pSubKey, 0, KEY_READ, hkHandle);
  If Result = 0 Then
    Begin
    // First call with lpData = NULL: retrieve required size into lpcbData
    Result := RegQueryValueEx(hkHandle, pValueName, Nil, @ValueType, Nil, @cbData);
    If Result = 0 Then
      Begin
      // Now, allocate the buffer and retrieve the data into it
      GetMem(pData, cbData);
      Result := RegQueryValueEx(hkHandle, pValueName, Nil, @ValueType, pData, @cbData);
      If Result <> 0 Then
        Begin
        ValueType := 0;
        If (pData <> Nil) And (cbData > 0) Then
          FreeMem(pData, cbData);
        pData := Nil;
        cbData := 0;
        End;
      End;
    RegCloseKey(hkHandle);
    End;
  End;

Function GetRegistryStringValue(Hive: HKEY; SubKey, ValueName: String; Var ValueData: String): DWORD;
  Var
    ValueType: DWORD;
    pData: PChar;
    cbData: DWORD;
  Begin
  ValueData := '';
  Result := ReadRegistryValue(HKEY_LOCAL_MACHINE, PChar(SubKey), PChar(ValueName), ValueType, pData, cbData);
  If (Result = 0) And (pData <> Nil) And (cbData > 0) Then
    Begin
    If (ValueType = REG_SZ) Or (ValueType = REG_EXPAND_SZ) Then
      ValueData := String(pData);
    FreeMem(pData, cbData);
    End;
  End;

Begin
End.
